//+------------------------------------------------------------------+
//|                                                   Test_Array.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern string  _ = " .";
extern int    Gross_Profit   = 3;                   //   
extern int    Profit_Factor  = 2;                   //   
extern int    Expected_Payoff= 1;                   //   
//--   
string Per, Last;
string Per1 = "StopLoss";
string Per2 = "TakeProfit";
string Per3 = "Sig1_period";
string Per4 = "Sig1_shift";
string Per5 = "Sig2_period";
string Per6 = "Sig2_shift";
string Per7 = "OrderTral";
string Per8 = "OrderPips";
string Per9 = "MinProfit";
string Per10 = "TrailingStop";
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
//----
      AnalizOptimiz(Gross_Profit,Profit_Factor,Expected_Payoff,Per1,Per2,Per3,Per4,Per5,Per6,Per7,Per8,Per9,Per10);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|   .                                   |
//+------------------------------------------------------------------+
int AnalizOptimiz(int Gross_Profit,int Profit_Factor,int Expected_Payoff,string Per1,string Per2,string Per3,string Per4,string Per5,string Per6,string Per7,string Per8,string Per9,string Per10){
   int    StepRes         = 128;                                               //   
//-------------------------------  ------------------------
   int    i,copyini,start,opttim,file,Pptk,OptimArraySize;
   int    P1,P2,P3,P4,P5,P6,P7,P8,P9,P10;
   int    P1k,P2k,P3k,P4k,P5k,P6k,P7k,P8k,P9k,P10k;
   int    ClStep,ClStepRazm,GrProf,GrProfRazm,TotTrad,TotTradRazm,ProfFact,ProfFactRazm,ExpPay,ExpPayRazm;
   int    text,index,kol,NumberStr,NumStr=0,test,CopyAr;
   int    GrosPr,PrCycle,Dubl;
   double kol1,kol2,kol3,kol4,kol5,kol6,kol7,kol8,kol9;
   double TotalTradesTransit,GrossProfitTransit,ExpectedPayoffTran;
   int    Perem1Transut,Perem2Transut,Perem3Transut,Perem4Transut,Perem5Transut,Perem6Transut,Perem7Transut,Perem8Transut,Perem9Transut,Perem10Transut;
   double PrFactDouble;
   double Prior1, Prior2, Prior3, transit, transit1, transit2, transit3, transit4, transit5, transit6, transit7, transit8, transit9, transit10, transit11;
   double NewPrior, NewPrior1, NewPrior2, NewPrior3, Sort, SortTrans;
   int    ResizeArayNew;
   string FileLine; 
   string ini;
   string CycleStep,GrossProfit,TotalTrades,ProfitFactor,ExpectedPayoff;
   string Perem1,Perem2,Perem3,Perem4,Perem5,Perem6,Perem7,Perem8,Perem9,Perem10; 
   string select;
   bool   nodubl;
//-----------------------------------   -------------------------
   string ArrayOpttim[15]; 
   string ArrayStrg[10]; 
   double ArrayData[10][14]; 
   double ArrayTrans[10][14];
  
   file=FileOpen("OptimizationReport.htm",FILE_READ,0x7F);                   //       
    if(file<0){
      Print("   ");
      return(0);
    } else {
      Print(" ");
      }
//----------------      ----------------------------------
    while(FileIsEnding(file)==false){                               //     - 
          FileLine=FileReadString(file);                            //    
          index=StringFind(FileLine, "title=", 10);                 //      
          if(index>0){
             ArrayResize(ArrayStrg,NumStr+1);                       //  
             ArrayStrg[NumStr]=FileLine;                            //     
             NumStr++;
    }}
    FileClose(file);                                                // 
    ArrayResize(ArrayData,NumStr);                                  //        
    
    Print("  ,  ", NumStr, " ");
    
    for(text=0;text<NumStr;text++){
        select=ArrayStrg[text]; 
//-------------------------------------------------------------------------
//                        (   )       
        //--------------------- -----------------------------
        ClStep=StringFind(select, "; \">",20)+4;                                       //  
        ClStepRazm=StringFind(select, "</td>",ClStep);                                 //  
        CycleStep = StringSubstr(select, ClStep, ClStepRazm-ClStep);                   // 
        //----------------   -------------------------------
        GrProf=StringFind(select, "<td class=mspt>",ClStepRazm-1);                     //  
        GrProfRazm=StringFind(select, "</td>",GrProf);                                 //  
        GrossProfit = StringSubstr(select, GrProf+15,GrProfRazm-(GrProf+15));          // 
         //-------------   -----------------------------
        TotTrad=StringFind(select, "<td>",GrProfRazm);                                 //  
        TotTradRazm=StringFind(select, "</td>",TotTrad);                               //  
        TotalTrades = StringSubstr(select, TotTrad+4,TotTradRazm-(TotTrad+4));         // 
        //------------- --------------------------------
        ProfFact=StringFind(select, "<td class=mspt>",TotTradRazm-1);                  //  
        ProfFactRazm=StringFind(select, "</td>",ProfFact);                             //  
        ProfitFactor = StringSubstr(select, ProfFact+15,ProfFactRazm-(ProfFact+15));   // 
       //-------------  ---------------------------------
        ExpPay=StringFind(select, "<td class=mspt>",ProfFactRazm-1);                   //  
        ExpPayRazm=StringFind(select, "</td>",ExpPay);                                 //  
        ExpectedPayoff = StringSubstr(select, ExpPay+15,ExpPayRazm-(ExpPay+15));       // 
        //------------------------------------------------------------------------
        //------------- -  ---------------------
//--- StopLoss
        P1=StringFind(select, Per1,20);                                                //  
        P1k=StringFind(select, ";",P1);                                                //  
        Perem1 = StringSubstr(select,P1+StringLen(Per1)+1,P1k-(P1+1+StringLen(Per1))); // 
//--- TakeProfit
        P2=StringFind(select, Per2,20);                                                //  
        P2k=StringFind(select, ";",P2);                                                //   
        Perem2 = StringSubstr(select,P2+StringLen(Per2)+1,P2k-(P2+1+StringLen(Per2))); // 
//--- Sig1_period
        P3=StringFind(select, Per3,20);                                                //  
        P3k=StringFind(select, ";",P3);                                                //  
        Perem3 = StringSubstr(select,P3+StringLen(Per3)+1,P3k-(P3+1+StringLen(Per3))); // 
//--- Sig1_shift
        P4=StringFind(select, Per4,20);                                                //  
        P4k=StringFind(select, ";",P4);                                                //  
        Perem4 = StringSubstr(select,P4+StringLen(Per4)+1,P4k-(P4+1+StringLen(Per4))); // 
//--- Sig2_period
        P5=StringFind(select, Per5,20);                                                //  
        P5k=StringFind(select, ";",P5);                                                //  
        Perem5 = StringSubstr(select,P5+StringLen(Per5)+1,P5k-(P5+1+StringLen(Per5))); // 
//--- Sig2_shift
        P6=StringFind(select, Per6,20);                                                //  
        P6k=StringFind(select, ";",P6);                                                //  
        Perem6 = StringSubstr(select,P6+StringLen(Per6)+1,P6k-(P6+1+StringLen(Per6))); // 
//--- OrderTral
        P7=StringFind(select, Per7,20);                                                //  
        P7k=StringFind(select, ";",P7);                                                //  
        Perem7 = StringSubstr(select,P7+StringLen(Per7)+1,P7k-(P7+1+StringLen(Per7))); // 
//--- OrderPips
        P8=StringFind(select, Per8,20);                                                //  
        P8k=StringFind(select, ";",P8);                                                //  
        Perem8 = StringSubstr(select,P8+StringLen(Per8)+1,P8k-(P8+1+StringLen(Per8))); // 
//--- MinProfit
        P9=StringFind(select, Per9,20);                                                //  
        P9k=StringFind(select, ";",P9);                                                //  
        Perem9 = StringSubstr(select,P9+StringLen(Per9)+1,P9k-(P9+1+StringLen(Per9))); // 
//--- TrailingStop
        P10=StringFind(select, Per10,20);                                                //  
        P10k=StringFind(select, ";",P10);                                                //  
        Perem10 = StringSubstr(select,P10+StringLen(Per10)+1,P10k-(P10+1+StringLen(Per10))); // 
//---                                                 
        Comment("   "); 
//-----------------------   ----------------------------
       TotalTradesTransit=NormalizeDouble(StrToDouble(TotalTrades),0);
       GrossProfitTransit=NormalizeDouble(StrToDouble(GrossProfit),2);
       ExpectedPayoffTran=NormalizeDouble(StrToDouble(ExpectedPayoff),2);
       nodubl=true;

          PrFactDouble = NormalizeDouble(StrToDouble(ProfitFactor),2);
          if(PrFactDouble==0){PrFactDouble=1000;}                                       // 0     
//--------------      -------------------       
           for(Dubl=0;Dubl<=text;Dubl++){                                               //    
               if(GrossProfitTransit == ArrayData[Dubl][1]){                            //     
                  if(TotalTradesTransit == ArrayData[Dubl][2]){                         //     
                     if(PrFactDouble == ArrayData[Dubl][3]){                            //    
                        if(ExpectedPayoffTran == ArrayData[Dubl][4]){                   //    
                           nodubl=false;                                                //  ,    
                         }}}}
           
//----------------      ----------------------
           if(nodubl){
              ArrayData[ResizeArayNew][1]=GrossProfitTransit;                                
              ArrayData[ResizeArayNew][2]=TotalTradesTransit;
              ArrayData[ResizeArayNew][3]=PrFactDouble;
              ArrayData[ResizeArayNew][4]=ExpectedPayoffTran;
              ArrayData[ResizeArayNew][5]=StrToInteger(Perem1);
              ArrayData[ResizeArayNew][6]=StrToInteger(Perem2);
              ArrayData[ResizeArayNew][7]=StrToInteger(Perem3);
              ArrayData[ResizeArayNew][8]=StrToInteger(Perem4);
              ArrayData[ResizeArayNew][9]=StrToInteger(Perem5);
              ArrayData[ResizeArayNew][10]=StrToInteger(Perem6);
              ArrayData[ResizeArayNew][11]=StrToInteger(Perem7);
              ArrayData[ResizeArayNew][12]=StrToInteger(Perem8);
              ArrayData[ResizeArayNew][13]=StrToInteger(Perem9);
              ArrayData[ResizeArayNew][14]=StrToInteger(Perem10);
              ResizeArayNew++;
    }}}
    Print ("  ArrayData ",ResizeArayNew," ");
   
   
   //|||||||||||||||||||||||||||||||      ||||||||||||||||||||||||||||||||||||                 
   int FileTst;
   int trs1,trs2,trs3,trs6,trs7,trs8,trs9,trs10,trs11,trs12,trs13,trs14,trs15,trs16;
   double trs4,trs5;
   FileTst=FileOpen("FileTest1.csv",FILE_CSV|FILE_WRITE,0x7F);           //   
   FileWrite(FileTst,"GrossProfit ; TotalTrades ; ProfitFactor ; ExpectedPayoff ;"+Per1+";"+Per2+";"+Per3+";"+Per4+";"+Per5+";"+Per6+";"+Per7+";"+Per8+";"+Per9+";"+Per10); 
   if(FileTst>0){
      for(i=0; i<ResizeArayNew; i++){
           trs2 = ArrayData[i][1];             
           trs3 = ArrayData[i][2];
           trs4 = ArrayData[i][3];             
           trs5 = ArrayData[i][4];             
           trs6 = ArrayData[i][5];
           trs7 = ArrayData[i][6];
           trs8 = ArrayData[i][7];
           trs9 = ArrayData[i][8];
           trs10 = ArrayData[i][9];
           trs11 = ArrayData[i][10];
           trs12 = ArrayData[i][11];
           trs13 = ArrayData[i][12];
           trs14 = ArrayData[i][13];
           trs15 = ArrayData[i][14];
           FileWrite(FileTst,trs2+";"+trs3+";"+trs4+";"+trs5+";"+trs6+";"+trs7+";"+trs8+";"+trs9+";"+trs10+";"+trs11+";"+trs12+";"+trs13+";"+trs14+";"+trs15); //   
      } 
      FileClose(FileTst);                                          //   
   }
   else{
        Print("     .   ",GetLastError());
        Comment(" !!!   FileTest1   ");
        return(0);
   }
//|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
FileTst=FileOpen("FileTest2.csv",FILE_CSV|FILE_WRITE,0x7F);                      
 
//---------------------------------------------------------------------- 
//   -           
   ArrayResize(ArrayTrans, ResizeArayNew-1);
   for(int PrioStep=1;PrioStep<4;PrioStep++){
   FileWrite(FileTst,"GrossProfit ; TotalTrades ; ProfitFactor ; ExpectedPayoff ;"+Per1+";"+Per2+";"+Per3+";"+Per4+";"+Per5+";"+Per6+";"+Per7+";"+Per8+";"+Per9+";"+Per10); 
       for(PrCycle=0;PrCycle<ResizeArayNew;PrCycle++){
           Sort     = ArrayData[PrCycle][0];
           Prior1   = ArrayData[PrCycle][1];             
           transit  = ArrayData[PrCycle][2];
           Prior2   = ArrayData[PrCycle][3];             
           Prior3   = ArrayData[PrCycle][4];             
           transit1 = ArrayData[PrCycle][5];
           transit2 = ArrayData[PrCycle][6];
           transit3 = ArrayData[PrCycle][7];
           transit4 = ArrayData[PrCycle][8]; 
           transit5 = ArrayData[PrCycle][9]; 
           transit6 = ArrayData[PrCycle][10]; 
           transit7 = ArrayData[PrCycle][11]; 
           transit8 = ArrayData[PrCycle][12]; 
           transit9 = ArrayData[PrCycle][13]; 
           transit10 = ArrayData[PrCycle][14]; 
           
           if(PrioStep==1){
              //  1 
              if(Gross_Profit   ==1){SortTrans=Prior1;}
              if(Profit_Factor  ==1){SortTrans=Prior2;}
              if(Expected_Payoff==1){SortTrans=Prior3;}
           }
           if(PrioStep==2){
              //
              if(Gross_Profit   ==1){Prior1=Sort;}
              if(Profit_Factor  ==1){Prior2=Sort;}
              if(Expected_Payoff==1){Prior3=Sort;} 
              //  2 
              if(Gross_Profit   ==2){SortTrans=Prior1;}
              if(Profit_Factor  ==2){SortTrans=Prior2;}
              if(Expected_Payoff==2){SortTrans=Prior3;}
           }
           if(PrioStep==3){
              //
              if(Gross_Profit   ==2){Prior1=Sort;}
              if(Profit_Factor  ==2){Prior2=Sort;}
              if(Expected_Payoff==2){Prior3=Sort;} 
              //  3 
              if(Gross_Profit   ==3){SortTrans=Prior1;}
              if(Profit_Factor  ==3){SortTrans=Prior2;}
              if(Expected_Payoff==3){SortTrans=Prior3;}
           }          
           ArrayTrans[PrCycle][0] = SortTrans;
           ArrayTrans[PrCycle][1] = Prior1;
           ArrayTrans[PrCycle][2] = transit;
           ArrayTrans[PrCycle][3] = Prior2;
           ArrayTrans[PrCycle][4] = Prior3;
           ArrayTrans[PrCycle][5] = transit1;
           ArrayTrans[PrCycle][6] = transit2;
           ArrayTrans[PrCycle][7] = transit3;
           ArrayTrans[PrCycle][8] = transit4;
           ArrayTrans[PrCycle][9] = transit5;
           ArrayTrans[PrCycle][10] = transit6;
           ArrayTrans[PrCycle][11] = transit7;
           ArrayTrans[PrCycle][12] = transit8;
           ArrayTrans[PrCycle][13] = transit9;
           ArrayTrans[PrCycle][14] = transit10;
       }
       ArraySort(ArrayTrans,StepRes,0,MODE_DESCEND);               // 
       ArrayResize(ArrayTrans,StepRes);                            // 
       for(CopyAr=0;CopyAr<StepRes;CopyAr++){
           ArrayData[CopyAr][0]=ArrayTrans[CopyAr][0];
           ArrayData[CopyAr][1]=ArrayTrans[CopyAr][1];
           ArrayData[CopyAr][2]=ArrayTrans[CopyAr][2];
           ArrayData[CopyAr][3]=ArrayTrans[CopyAr][3];
           ArrayData[CopyAr][4]=ArrayTrans[CopyAr][4];             
           ArrayData[CopyAr][5]=ArrayTrans[CopyAr][5];             //Per1     1 
           ArrayData[CopyAr][6]=ArrayTrans[CopyAr][6];             //Per2     2
           ArrayData[CopyAr][7]=ArrayTrans[CopyAr][7];             //Per3     3
           ArrayData[CopyAr][8]=ArrayTrans[CopyAr][8];             //Per4     3
           ArrayData[CopyAr][9]=ArrayTrans[CopyAr][9];             //Per5     3
           ArrayData[CopyAr][10]=ArrayTrans[CopyAr][10];           //Per6     3
           ArrayData[CopyAr][11]=ArrayTrans[CopyAr][11];           //Per7     3
           ArrayData[CopyAr][12]=ArrayTrans[CopyAr][12];           //Per8     3
           ArrayData[CopyAr][13]=ArrayTrans[CopyAr][13];           //Per9     3
           ArrayData[CopyAr][14]=ArrayTrans[CopyAr][14];           //Per10     3

      }
//|||||||||||||||||||||||||||||||      ||||||||||||||||||||||||||||||||||||                 
   
   if(FileTst>0){
      for(i=0; i<StepRes; i++){
          trs2 = ArrayData[i][1];             
          trs3 = ArrayData[i][2];
          trs4 = ArrayData[i][3];             
          trs5 = ArrayData[i][4];             
          trs6 = ArrayData[i][5];
          trs7 = ArrayData[i][6];
          trs8 = ArrayData[i][7];
          trs9 = ArrayData[i][8];
          trs10 = ArrayData[i][9];
          trs11 = ArrayData[i][10];
          trs12 = ArrayData[i][11];
          trs13 = ArrayData[i][12];
          trs14 = ArrayData[i][13];
          trs15 = ArrayData[i][14];
          FileWrite(FileTst,trs2+";"+trs3+";"+trs4+";"+trs5+";"+trs6+";"+trs7+";"+trs8+";"+trs9+";"+trs10+";"+trs11+";"+trs12+";"+trs13+";"+trs14+";"+trs15);
   }} 
   else{
        Print("     .   ",GetLastError());
        Comment(" !!!   FileTest2   ");
        return(0);
   }
//|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       StepRes=StepRes/2;
   } 
    FileClose(FileTst);                                          //   
     
       //    
       double Peremen1 = ArrayTrans[0][5];                         
       double Peremen2 = ArrayTrans[0][6];
       double Peremen3 = ArrayTrans[0][7];
       double Peremen4 = ArrayTrans[0][8];
       double Peremen5 = ArrayTrans[0][9];
       double Peremen6 = ArrayTrans[0][10];
       double Peremen7 = ArrayTrans[0][11];
       double Peremen8 = ArrayTrans[0][12];
       double Peremen9 = ArrayTrans[0][13];
       double Peremen10 = ArrayTrans[0][14];

       //         
       GlobalVariableSet("Per",TimeCurrent());
       if(Per1!=""){GlobalVariableSet(Per1,Peremen1);}
       if(Per2!=""){GlobalVariableSet(Per2,Peremen2);}
       if(Per3!=""){GlobalVariableSet(Per3,Peremen3);}
       if(Per4!=""){GlobalVariableSet(Per4,Peremen4);}
       if(Per5!=""){GlobalVariableSet(Per5,Peremen5);}
       if(Per6!=""){GlobalVariableSet(Per6,Peremen6);}
       if(Per7!=""){GlobalVariableSet(Per7,Peremen7);}
       if(Per8!=""){GlobalVariableSet(Per8,Peremen8);}
       if(Per9!=""){GlobalVariableSet(Per9,Peremen9);}
       if(Per10!=""){GlobalVariableSet(Per10,Peremen10);}

       Comment(Per1," ",Peremen1,"  | ",Per2," ",Peremen2,"  | ",Per3," ",Peremen3,"  | ",Per4," ",Peremen4,"  | ",Per5," ",Peremen5,"  | ",Per6," ",Peremen6,"  | ",Per7," ",Peremen7,"  | ",Per8," ",Peremen8,"  | ",Per9," ",Peremen9,"  | ",Per10," ",Peremen10);
       Print(Per1," ",Peremen1,"  | ",Per2," ",Peremen2,"  | ",Per3," ",Peremen3,"  | ",Per4," ",Peremen4,"  | ",Per5," ",Peremen5,"  | ",Per6," ",Peremen6,"  | ",Per7," ",Peremen7,"  | ",Per8," ",Peremen8,"  | ",Per9," ",Peremen9,"  | ",Per10," ",Peremen10);
       
       //FileDelete("OptimizationReport.htm");                           //     
       //FileDelete("OptimizationReport.gif");                           //     

 }  //  